/*
	tray2file.c

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include <btron/btron.h>
#include <btron/hmi.h>
#include <errcode.h>
#include <bstdio.h>
#include <bstdlib.h>

/* $B%(%s%G%#%"%sJQ49$,I,MW$K$J$C$?;~$N$?$a$N!"3HD%MQ(B */
#define	XeH(x)	(x)
#define	XeW(x)	(x)

/* $B4IM}>pJs%;%0%a%s%H(B */
LOCAL	UH	InfoSeg[] = {
	XeH(TC_SPEC | TS_INFO),		// $B4IM}>pJs%;%0%a%s%H(B
	XeH(0x0006),			// $B%G!<%?K\BN$N%P%$%HD9(B
	XeH(0x0000),			// $B9`L\(BID$B!J(B0:TAD$B5,3J$N%P!<%8%g%sHV9f!K(B
	XeH(0x0002),			// $B9`L\%G!<%?$N%P%$%HD9(B
	XeH(0x0122),			// TAD 1.22$B$K=`5r(B
};

/* $BJ8=q3+;O%;%0%a%s%H(B */
LOCAL	UH	TextSeg[] = {
	XeH(TC_SPEC | TS_TEXT),		// $BJ8>O3+;O%;%0%a%s%H(B
	XeH(0x0018),			// $B%G!<%?K\BN$N%P%$%HD9(B
	XeH(0x0000),
	XeH(0x0000),
	XeH(0x0000),
	XeH(0x0000),
	XeH(0x0000),
	XeH(0x0000),
	XeH(0x0000),
	XeH(0x0000),
	XeH(0xff88),
	XeH(0xff88),
	XeH(0x0021),
	XeH(0x0000),
};

/* $BJ8>O=*N;%;%0%a%s%H(B */
LOCAL	UH	TextEndSeg[] = {
	XeH(TC_SPEC | TS_TEXTEND),	// $BJ8>O=*N;%;%0%a%s%H(B
	XeH(0x0000),			// $B%G!<%?K\BN$N%P%$%HD9(B
};

/* $B4pK\J8=qJT=8$+$i<h$j=P$7$?<B9T5!G=IUd5(B */
LOCAL	UH	TXEDFusen[] = {
	XeH(0x0000), XeH(0x0000), XeH(0x0000), XeH(0x0000),	// RECT view
	XeH(0x0010),						// CHSIZE chsz
	XeH(0x0000), XeH(0x1000),				// UH frcol[2]
	XeH(0x0000), XeH(0x1000),				// UH chcol[2]
	XeH(0xffff), XeH(0x10ff),				// UH tbcol[2]
	XeH(0x0004),						// UH pict
	XeH(0x8000), XeH(0x0003), XeH(0x8000),			// UH appl[3]
	XeH(0x3470), XeH(0x4b5c), XeH(0x4a38), XeH(0x3e4f),	// TC name[16]
	XeH(0x4a54), XeH(0x3d38), XeH(0x0000), XeH(0x0000),
	XeH(0x0000), XeH(0x0000), XeH(0x0000), XeH(0x0000),
	XeH(0x0000), XeH(0x0000), XeH(0x0000), XeH(0x0000),
	XeH(0x4a38), XeH(0x3e4f), XeH(0x0000), XeH(0x0000),	// TC dtype[16]
	XeH(0x0000), XeH(0x0000), XeH(0x0000), XeH(0x0000),
	XeH(0x0000), XeH(0x0000), XeH(0x0000), XeH(0x0000),
	XeH(0x0000), XeH(0x0000), XeH(0x0000), XeH(0x0000),
	XeH(0x0020),						// UH dlen
	XeH(0x0002), XeH(0x0000), XeH(0x0000), XeH(0x0000),	// unknown...
	XeH(0x0280), XeH(0x017c), XeH(0x0000), XeH(0x0000),
	XeH(0x0000), XeH(0x0000), XeH(0x0000), XeH(0xffff),
	XeH(0x10ff), XeH(0x0000), XeH(0x0000), XeH(0x0000),
};

/* $B%U%!%$%k=q$-=P$7(B */
LOCAL	W	save_to_file(TC *name, TRAYREC *data, W rec)
{
	W	err, i, fd;
	LINK	l;

	/* $B%j%s%/<hF@(B */
	err = get_lnk(NULL, &l, F_NORM);
	if (err < ER_OK) {
		printf("save_to_file: get_lnk %d\n", err);
		goto fin0;
	}

	/* $B=PNO%U%!%$%k:n@.(B */
	err = cre_fil(&l, name, NULL, 0, F_FIX);
	if (err < ER_OK) {
		printf("save_to_file: cre_fil %d\n", err);
		goto fin0;
	}
	fd = err;

	/* $B4IM}>pJs%;%0%a%s%H$r=PNO(B */
	err = apd_rec(fd, (UB *)InfoSeg, sizeof(InfoSeg), 1, 0, 0);
	if (err < ER_OK) {
		printf("save_to_file: apd_rec %d\n", err);
		goto fin1;
	}

	/* $B=*C<%l%3!<%I$N0l$DA0$K0\F0$9$k(B */
	err = see_rec(fd, -1, -1, NULL);
	if (err < ER_OK) {
		printf("save_to_file: see_rec %d\n", err);
		goto fin1;
	}

	/* $BJ8=q3+;O%l%3!<%I$r=PNO(B */
	err = wri_rec(fd, -1, (UB *)TextSeg, sizeof(TextSeg), NULL, NULL, 0);
	if (err < ER_OK) {
		printf("save_to_file: wri_rec %d\n", err);
		goto fin1;
	}

	/* $BJ8>O%;%0%a%s%HNs$N$_A*Br$7$F=PNO(B */
	for (i = 0; i < rec; i++) {
		if (data[i].id != TR_TEXT) continue;

		err = wri_rec(fd, -1, data[i].dt, data[i].len, NULL, NULL, 0);
		if (err < ER_OK) {
			printf("save_to_file: wri_rec %d\n", err);
			goto fin1;
		}
	}

	/* $BJ8>O=*N;%l%3!<%I$r=PNO(B */
	err = wri_rec(fd, -1, (UB *)TextEndSeg, sizeof(TextEndSeg),
		     NULL, NULL, 0);
	if (err < ER_OK) {
		printf("save_to_file: wri_rec %d\n", err);
		goto fin1;
	}

	/* $B4pK\J8=qJT=8$N<B9T5!G=IUd5$rE=$jIU$1$k(B */
	err = apd_rec(fd, (UB *)TXEDFusen, sizeof(TXEDFusen), 8, 0, 0);
	if (err < ER_OK) {
		printf("save_to_file: apd_rec %d\n", err);
		goto fin1;
	}

 fin1:
	cls_fil(fd);
 fin0:
	return err;
}

/* main */
EXPORT	ERR	main(W ac, TC *av[])
{
	W	err, rec, size, asize;
	TRAYREC	*data;

	/* $B0z?t$N%A%'%C%/(B */
	if (ac < 2) {
		printf("usage: %S [filename]\n", av[0]);
		err = ER_PAR;	
		goto fin0;
	}

	/* $B%l%3!<%IA4BN$N%5%$%:!&%l%3!<%I?t$N<hF@(B */
	err = tpop_dat(NULL, 0, &size, -1, NULL);
	if (err < ER_OK) {
		printf("main: tpop_dat %d\n", err);
		goto fin0;
	}
	rec = err;

	/* $B%l%3!<%I$,B8:_$7$J$$>l9g$O$3$3$G=*N;(B */
	if (!size) {
		printf("main: no tray data\n");
		err = ER_NOEXS;
		goto fin0;
	}

	/* $B%a%b%j3NJ](B */
	data = malloc(size);
	if (data == NULL) {
		printf("main: malloc NULL\n");
		err = ER_NOMEM;
		goto fin0;
	}

	/* $B%l%3!<%IA4BN$NFI$_=P$7(B */
	err = tpop_dat(data, size, &asize, -1, NULL);
	if (err < ER_OK) {
		printf("tpop_dat %d\n", err);
		goto fin1;
	}

	/* $B;XDj$5$l$?%U%!%$%k$H$7$F=PNO(B */
	err = save_to_file(av[1], data, rec);
	if (err < ER_OK) {
		printf("save_to_file %d\n", err);
		goto fin1;
	}

 fin1:
	free(data);
 fin0:
	return err;
}
